default:
  image: node:18
  before_script:
    - npm ci --cache .npm --prefer-offline
  cache:
    key: ${CI_COMMIT_REF_SLUG}
    paths:
      - .npm/
  artifacts:
    public: false

variables:
  GL_TOKEN: ${API_PAT}

.on_published_branches_commit:
  only:
    refs:
      - master
      - next

.on_merge_requests:
  only:
    refs:
      - merge_requests

stages:
  - lint
  - build
  - release

lint_code:
  extends: .on_merge_requests
  stage: lint
  script:
    - npm run lint:all

lint_commit_messages:
  extends: .on_merge_requests
  stage: lint
  script:
    - git fetch origin $CI_MERGE_REQUEST_TARGET_BRANCH_NAME
    - npm run commitlint -- --from $(git merge-base origin/$CI_MERGE_REQUEST_TARGET_BRANCH_NAME HEAD)

build_package:
  extends: .on_published_branches_commit
  stage: build
  script:
    - npm run build
  artifacts:
    paths:
      - dist/

publish:
  extends: .on_published_branches_commit
  stage: release
  script:
    - npm run semantic-release
